#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "barcode.h"

int main(int argc, char **argv)
{
    struct Barcode_Item* bc;
    char *line;
    
    if (argc < 2) {
        line = malloc(20);
        //strcpy(line, "12345678900123456789");
        strcpy(line, "1-23456-789-0 12345");
        
    }
    else {
        line = malloc(strlen(argv[1]));
        strcpy(line, argv[1]);
    }
        
    bc = Barcode_Create(line);
    if (!bc) {
        fprintf(stderr, "%s: Barcode_Create(): %s\n", argv[0], strerror(errno));
        exit(1);
    }
    char ascii[strlen(bc->ascii)];
    strcpy(ascii, bc->ascii);
    printf("ascii: %s\n", ascii);
    
    //if (Barcode_Encode(bc, BARCODE_128) < 0) {
    if (Barcode_Encode(bc, BARCODE_ISBN) < 0) {
        fprintf(stderr, "%s: can't encode \"%s\": %s\n", argv[0], line, strerror(bc->error));
    }
    
    char partial[strlen(bc->partial)];
    strcpy(partial, bc->partial);
    printf("partial: %s\n", partial);
    
    char textinfo[strlen(bc->textinfo)];
    strcpy(textinfo, bc->textinfo);
    printf("textinfo: %s\n", textinfo);
    
    char encoding[strlen(bc->encoding)];
    strcpy(encoding, bc->encoding);
    printf("encoding: %s\n", encoding);
    
    printf("width: %d\n", bc->width);
    printf("height: %d\n", bc->height);
    printf("xoff: %d\n", bc->xoff);
    printf("yoff: %d\n", bc->yoff);
    printf("margin: %d\n", bc->margin);
    printf("scalef: %f\n", bc->scalef);
    printf("error: %d\n", bc->error);
    
    Barcode_Delete(bc);
    free(line);
    
    return 0;
}
